from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *

from model import *
from controler import *


class PacmanScene(QGraphicsScene):
    def __init__(self, parent, controler):
        super().__init__(parent)
    
    def refresh(self):
        pass
    
    def mousePressEvent(self, e):
        pass


class PacmanView(QGraphicsView):
    def __init__(self, parent, controler):
        super().__init__(parent)
        self.scene = PacmanScene(self, controler)
        self.setScene(self.scene)

    def resizeEvent(self, event):
        self.fitInView(self.scene.sceneRect(), Qt.KeepAspectRatio)


class PacmanParams(QWidget):
    def __init__(self, parent, controler):
        pass
    
    def on_start(self):
        pass
    
    def on_stop(self):
        pass

    def on_change_speed(self):
        pass

    def refresh(self):
        pass


class PacmanWidget(QWidget):
    def __init__(self, parent, controler):
        super().__init__(parent)
        view = PacmanView(self, controler)
        params = PacmanParams(self, controler)
        layout = QHBoxLayout()
        layout.addWidget(params)
        layout.addWidget(view)
        self.setLayout(layout)


class PacmanWindow(QMainWindow):
    def __init__(self, controler):
        super().__init__()
        self.controler = controler
        self.setWindowTitle("Mini-Pacman")
        mainwidget = PacmanWidget(self, controler)
        self.setCentralWidget(mainwidget)

    def keyPressEvent(self, e):
        pass


def main():
    app = QApplication([])
    controler = PacmanControler()
    win = PacmanWindow(controler)
    win.show()
    app.exec()

if __name__ == "__main__":
    main()